# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from realsense_ros/or_image_info.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import realsense_ros.msg

class or_image_info(genpy.Message):
  _md5sum = "7e6cff19321dc5bd7f6ca1cd32dafd06"
  _type = "realsense_ros/or_image_info"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# IDL struct ::or_image::info
uint32 seq
or_sensor_pixmap_roi[] roi
or_image_distortion[] distortion
or_image_intrinsic[] intrinsics
or_image_extrinsic[] extrinsics

================================================================================
MSG: realsense_ros/or_sensor_pixmap_roi
# IDL struct ::or::sensor::pixmap_roi
uint32 subsx
uint32 subsy
uint32 x
uint32 y
uint32 width
uint32 height

================================================================================
MSG: realsense_ros/or_image_distortion
# IDL struct ::or_image::distortion
or_image_distortion_model model
float64[] coeffs

================================================================================
MSG: realsense_ros/or_image_distortion_model
# IDL enum ::or_image::distortion_model
uint32 or_image_R3T2 = 0

uint32 value

================================================================================
MSG: realsense_ros/or_image_intrinsic
# IDL struct ::or_image::intrinsic
float64 fx
float64 fy
float64 cx
float64 cy

================================================================================
MSG: realsense_ros/or_image_extrinsic
# IDL struct ::or_image::extrinsic
or_t3d_pos T
or_t3d_att R

================================================================================
MSG: realsense_ros/or_t3d_pos
# IDL struct ::or::t3d::pos
float64 x
float64 y
float64 z

================================================================================
MSG: realsense_ros/or_t3d_att
# IDL struct ::or::t3d::att
float64 qw
float64 qx
float64 qy
float64 qz
"""
  __slots__ = ['seq','roi','distortion','intrinsics','extrinsics']
  _slot_types = ['uint32','realsense_ros/or_sensor_pixmap_roi[]','realsense_ros/or_image_distortion[]','realsense_ros/or_image_intrinsic[]','realsense_ros/or_image_extrinsic[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       seq,roi,distortion,intrinsics,extrinsics

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(or_image_info, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.seq is None:
        self.seq = 0
      if self.roi is None:
        self.roi = []
      if self.distortion is None:
        self.distortion = []
      if self.intrinsics is None:
        self.intrinsics = []
      if self.extrinsics is None:
        self.extrinsics = []
    else:
      self.seq = 0
      self.roi = []
      self.distortion = []
      self.intrinsics = []
      self.extrinsics = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.seq
      buff.write(_get_struct_I().pack(_x))
      length = len(self.roi)
      buff.write(_struct_I.pack(length))
      for val1 in self.roi:
        _x = val1
        buff.write(_get_struct_6I().pack(_x.subsx, _x.subsy, _x.x, _x.y, _x.width, _x.height))
      length = len(self.distortion)
      buff.write(_struct_I.pack(length))
      for val1 in self.distortion:
        _v1 = val1.model
        _x = _v1.value
        buff.write(_get_struct_I().pack(_x))
        length = len(val1.coeffs)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.Struct(pattern).pack(*val1.coeffs))
      length = len(self.intrinsics)
      buff.write(_struct_I.pack(length))
      for val1 in self.intrinsics:
        _x = val1
        buff.write(_get_struct_4d().pack(_x.fx, _x.fy, _x.cx, _x.cy))
      length = len(self.extrinsics)
      buff.write(_struct_I.pack(length))
      for val1 in self.extrinsics:
        _v2 = val1.T
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = val1.R
        _x = _v3
        buff.write(_get_struct_4d().pack(_x.qw, _x.qx, _x.qy, _x.qz))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.roi is None:
        self.roi = None
      if self.distortion is None:
        self.distortion = None
      if self.intrinsics is None:
        self.intrinsics = None
      if self.extrinsics is None:
        self.extrinsics = None
      end = 0
      start = end
      end += 4
      (self.seq,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.roi = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_sensor_pixmap_roi()
        _x = val1
        start = end
        end += 24
        (_x.subsx, _x.subsy, _x.x, _x.y, _x.width, _x.height,) = _get_struct_6I().unpack(str[start:end])
        self.roi.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.distortion = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_image_distortion()
        _v4 = val1.model
        start = end
        end += 4
        (_v4.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.coeffs = s.unpack(str[start:end])
        self.distortion.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.intrinsics = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_image_intrinsic()
        _x = val1
        start = end
        end += 32
        (_x.fx, _x.fy, _x.cx, _x.cy,) = _get_struct_4d().unpack(str[start:end])
        self.intrinsics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.extrinsics = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_image_extrinsic()
        _v5 = val1.T
        _x = _v5
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v6 = val1.R
        _x = _v6
        start = end
        end += 32
        (_x.qw, _x.qx, _x.qy, _x.qz,) = _get_struct_4d().unpack(str[start:end])
        self.extrinsics.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.seq
      buff.write(_get_struct_I().pack(_x))
      length = len(self.roi)
      buff.write(_struct_I.pack(length))
      for val1 in self.roi:
        _x = val1
        buff.write(_get_struct_6I().pack(_x.subsx, _x.subsy, _x.x, _x.y, _x.width, _x.height))
      length = len(self.distortion)
      buff.write(_struct_I.pack(length))
      for val1 in self.distortion:
        _v7 = val1.model
        _x = _v7.value
        buff.write(_get_struct_I().pack(_x))
        length = len(val1.coeffs)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.coeffs.tostring())
      length = len(self.intrinsics)
      buff.write(_struct_I.pack(length))
      for val1 in self.intrinsics:
        _x = val1
        buff.write(_get_struct_4d().pack(_x.fx, _x.fy, _x.cx, _x.cy))
      length = len(self.extrinsics)
      buff.write(_struct_I.pack(length))
      for val1 in self.extrinsics:
        _v8 = val1.T
        _x = _v8
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v9 = val1.R
        _x = _v9
        buff.write(_get_struct_4d().pack(_x.qw, _x.qx, _x.qy, _x.qz))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.roi is None:
        self.roi = None
      if self.distortion is None:
        self.distortion = None
      if self.intrinsics is None:
        self.intrinsics = None
      if self.extrinsics is None:
        self.extrinsics = None
      end = 0
      start = end
      end += 4
      (self.seq,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.roi = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_sensor_pixmap_roi()
        _x = val1
        start = end
        end += 24
        (_x.subsx, _x.subsy, _x.x, _x.y, _x.width, _x.height,) = _get_struct_6I().unpack(str[start:end])
        self.roi.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.distortion = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_image_distortion()
        _v10 = val1.model
        start = end
        end += 4
        (_v10.value,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.coeffs = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.distortion.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.intrinsics = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_image_intrinsic()
        _x = val1
        start = end
        end += 32
        (_x.fx, _x.fy, _x.cx, _x.cy,) = _get_struct_4d().unpack(str[start:end])
        self.intrinsics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.extrinsics = []
      for i in range(0, length):
        val1 = realsense_ros.msg.or_image_extrinsic()
        _v11 = val1.T
        _x = _v11
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v12 = val1.R
        _x = _v12
        start = end
        end += 32
        (_x.qw, _x.qx, _x.qy, _x.qz,) = _get_struct_4d().unpack(str[start:end])
        self.extrinsics.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_6I = None
def _get_struct_6I():
    global _struct_6I
    if _struct_6I is None:
        _struct_6I = struct.Struct("<6I")
    return _struct_6I
